/*********************************************************************
 * Quick and dirty bios dump utility..
 * Distributed as is
 *                      -pukko
 *
 * Fixed for the new build environment by Shine.
 */

#include <tamtypes.h>
#include <kernel.h>
#include <fileio.h>
#include <io_common.h>
#include <kernel.h>
#include <sifrpc.h>

#include "asm.h"

#define DUMP_SIZE (4*1024*1024)
unsigned int buf[DUMP_SIZE / 4];

int
main()
{

    int i;
    unsigned int *ptr;
    int fd;


    SifInitRpc(0);
    fioInit();

    // Syscalls
    k_RFU116(254, su_readMem);

    FlushCache(0);
    FlushCache(2);

    nprintf("BIOS dump util\n"
               "              - pukko\n\n");

    nprintf("Read mem\n");
    
    // Bios start
    ptr = (unsigned int *)0xbfc00000;
    for (i=0; i<DUMP_SIZE/4; i++) {
        buf[i] = k_readMem(ptr);
        ptr++;
    }
    
    nprintf("open file for writing\n");
    fd = fioOpen("host:bios.bin", O_WRONLY | O_TRUNC | O_CREAT);
    if (fd > 0) {
        nprintf("open ok\n");
        if (fioWrite(fd, buf, DUMP_SIZE) > 0) {
            nprintf("write ok\n");
        }
        else {
            nprintf("write failed\n");
        }
    }
    else {
        nprintf("open failed %d\n", fd);
    }
    fioClose(fd);
    nprintf("Done!\n");
    
    return 0;
}
